package com.futu.goose.user.controller;

import com.futu.goose.user.dto.WXAuth;
import com.futu.goose.user.service.impl.WechatUsersServiceImpl;
import com.futu.goose.common.util.Result;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;

@RestController
@RequestMapping("/wx")
public class WeChatController {

    @Autowired
    private WechatUsersServiceImpl wechatUsersService;

    @GetMapping("/getSessionId")
    public Result getSessionId(String code) {
        if (code == null || code.trim().isEmpty()) {
            return Result.ERROR("code不能为空");
        }
        return wechatUsersService.getSessionId(code);
    }

    @PostMapping("/authLogin")
    public Result authLogin(@RequestBody @Validated WXAuth wxAuth) {
        return wechatUsersService.authLogin(wxAuth);
    }
}
